<?php

/**
 * @file
 * Views integration for connect module
 */

/**
 * Implementation of hook_views_data.
 */
function connect_views_data() {

  $data = array();

  $data['connect_data']['table']['group'] = t('Connect');

  $data['connect_data']['table']['join'] = array(
    'node' => array(
      'left_field' => 'nid',
      'field' => 'nid',
    ),
  );

  $data['connect_data']['pid'] = array(
    'title' => t('Parent'),
    'help'  => t('The campaign or parent node'),
    'relationship' => array(
      'base'    => 'node',
      'field'   => 'nid',
      'handler' => 'views_handler_relationship',
      'label'   => t('Connect campaign'),
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
      'name field' => 'Campaign',
      'numeric' => TRUE,
      'validate type' => 'nid',
    ),
  );

  $data['connect_data']['nid'] = array(
    'title' => t('Child'),
    'help'  => t('The participant or child node'),
    'relationship' => array(
      'base'    => 'node',
      'field'   => 'nid',
      'handler' => 'views_handler_relationship',
      'label'   => t('Connect participant'),
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
      'name field' => 'Participant',
      'numeric' => TRUE,
      'validate type' => 'nid',
    ),
  );
  return $data;
}
